Index: uspace/lib/drv/generic/driver.c
===================================================================
--- uspace/lib/drv/generic/driver.c	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/drv/generic/driver.c	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -48,4 +48,5 @@
 #include <ctype.h>
 #include <errno.h>
+#include <inttypes.h>
 
 #include <ipc/driver.h>
@@ -80,5 +81,5 @@
 static void driver_irq_handler(ipc_callid_t iid, ipc_call_t *icall)
 {
-	int id = (int)IPC_GET_METHOD(*icall);
+	int id = (int)IPC_GET_IMETHOD(*icall);
 	interrupt_context_t *ctx;
 	
@@ -164,4 +165,6 @@
 	
 	devman_handle_t dev_handle =  IPC_GET_ARG1(*icall);
+    	devman_handle_t parent_dev_handle = IPC_GET_ARG2(*icall);
+    
 	device_t *dev = create_device();
 	dev->handle = dev_handle;
@@ -171,10 +174,12 @@
 	
 	add_to_devices_list(dev);
+	dev->parent = driver_get_device(&devices, parent_dev_handle);
+	
 	res = driver->driver_ops->add_device(dev);
 	if (0 == res) {
-		printf("%s: new device with handle = %x was added.\n",
+		printf("%s: new device with handle=%" PRIun " was added.\n",
 		    driver->name, dev_handle);
 	} else {
-		printf("%s: failed to add a new device with handle = %d.\n",
+		printf("%s: failed to add a new device with handle = %" PRIun ".\n",
 		    driver->name, dev_handle);
 		remove_from_devices_list(dev);
@@ -195,5 +200,5 @@
 		ipc_callid_t callid = async_get_call(&call);
 
-		switch (IPC_GET_METHOD(call)) {
+		switch (IPC_GET_IMETHOD(call)) {
 		case IPC_M_PHONE_HUNGUP:
 			cont = false;
@@ -203,6 +208,5 @@
 			break;
 		default:
-			if (!(callid & IPC_CALLID_NOTIFICATION))
-				ipc_answer_0(callid, ENOENT);
+			ipc_answer_0(callid, ENOENT);
 		}
 	}
@@ -226,5 +230,5 @@
 	if (dev == NULL) {
 		printf("%s: driver_connection_gen error - no device with handle"
-		    " %x was found.\n", driver->name, handle);
+		    " %" PRIun " was found.\n", driver->name, handle);
 		ipc_answer_0(iid, ENOENT);
 		return;
@@ -250,5 +254,5 @@
 		ipc_call_t call;
 		callid = async_get_call(&call);
-		ipcarg_t method = IPC_GET_METHOD(call);
+		sysarg_t method = IPC_GET_IMETHOD(call);
 		int iface_idx;
 		
@@ -290,5 +294,5 @@
 				printf("%s: driver_connection_gen error - ",
 				    driver->name);
-				printf("device with handle %d has no interface "
+				printf("device with handle %" PRIun " has no interface "
 				    "with id %d.\n", handle, iface_idx);
 				ipc_answer_0(callid, ENOTSUP);
@@ -304,5 +308,5 @@
 
 			/* get the method of the remote interface */
-			ipcarg_t iface_method_idx = IPC_GET_ARG1(call);
+			sysarg_t iface_method_idx = IPC_GET_ARG1(call);
 			remote_iface_func_ptr_t iface_method_ptr =
 			    get_remote_method(rem_iface, iface_method_idx);
@@ -342,5 +346,5 @@
 {
 	/* Select interface */
-	switch ((ipcarg_t) (IPC_GET_ARG1(*icall))) {
+	switch ((sysarg_t) (IPC_GET_ARG1(*icall))) {
 	case DRIVER_DEVMAN:
 		/* handle PnP events from device manager */
@@ -377,4 +381,57 @@
 }
 
+/** Wrapper for child_device_register for devices with single match id.
+ *
+ * @param parent Parent device.
+ * @param child_name Child device name.
+ * @param child_match_id Child device match id.
+ * @param child_match_score Child device match score.
+ * @return Error code.
+ */
+int child_device_register_wrapper(device_t *parent, const char *child_name,
+    const char *child_match_id, int child_match_score)
+{
+	device_t *child = NULL;
+	match_id_t *match_id = NULL;
+	int rc;
+
+	child = create_device();
+	if (child == NULL) {
+		rc = ENOMEM;
+		goto failure;
+	}
+
+	child->name = child_name;
+
+	match_id = create_match_id();
+	if (match_id == NULL) {
+		rc = ENOMEM;
+		goto failure;
+	}
+
+	match_id->id = child_match_id;
+	match_id->score = child_match_score;
+	add_match_id(&child->match_ids, match_id);
+
+	rc = child_device_register(child, parent);
+	if (EOK != rc)
+		goto failure;
+
+	return EOK;
+
+failure:
+	if (match_id != NULL) {
+		match_id->id = NULL;
+		delete_match_id(match_id);
+	}
+
+	if (child != NULL) {
+		child->name = NULL;
+		delete_device(child);
+	}
+
+	return rc;
+}
+
 int driver_main(driver_t *drv)
 {
Index: uspace/lib/drv/include/driver.h
===================================================================
--- uspace/lib/drv/include/driver.h	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/drv/include/driver.h	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -79,5 +79,5 @@
 
 remote_iface_t *get_remote_iface(int);
-remote_iface_func_ptr_t get_remote_method(remote_iface_t *, ipcarg_t);
+remote_iface_func_ptr_t get_remote_method(remote_iface_t *, sysarg_t);
 
 
@@ -199,4 +199,5 @@
 
 int child_device_register(device_t *, device_t *);
+int child_device_register_wrapper(device_t *, const char *, const char *, int);
 
 
Index: uspace/lib/fs/libfs.c
===================================================================
--- uspace/lib/fs/libfs.c	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/fs/libfs.c	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -155,5 +155,5 @@
 	devmap_handle_t mr_devmap_handle = (devmap_handle_t) IPC_GET_ARG4(*request);
 	int res;
-	ipcarg_t rc;
+	sysarg_t rc;
 	
 	ipc_call_t call;
@@ -163,5 +163,5 @@
 	callid = async_get_call(&call);
 	int mountee_phone = (int) IPC_GET_ARG1(call);
-	if ((IPC_GET_METHOD(call) != IPC_M_CONNECTION_CLONE) ||
+	if ((IPC_GET_IMETHOD(call) != IPC_M_CONNECTION_CLONE) ||
 	    (mountee_phone < 0)) {
 		ipc_answer_0(callid, EINVAL);
Index: uspace/lib/fs/libfs.h
===================================================================
--- uspace/lib/fs/libfs.h	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/fs/libfs.h	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -86,5 +86,5 @@
 typedef struct {
 	int fs_handle;           /**< File system handle. */
-	ipcarg_t vfs_phonehash;  /**< Initial VFS phonehash. */
+	sysarg_t vfs_phonehash;  /**< Initial VFS phonehash. */
 	uint8_t *plb_ro;         /**< Read-only PLB view. */
 } fs_reg_t;
Index: uspace/lib/net/generic/generic.c
===================================================================
--- uspace/lib/net/generic/generic.c	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/net/generic/generic.c	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -59,6 +59,6 @@
     int state, services_t target)
 {
-	async_msg_3(phone, (ipcarg_t) message, (ipcarg_t) device_id,
-	    (ipcarg_t) state, target);
+	async_msg_3(phone, (sysarg_t) message, (sysarg_t) device_id,
+	    (sysarg_t) state, target);
 	
 	return EOK;
@@ -81,6 +81,6 @@
     int arg2, services_t service)
 {
-	return (int) async_req_3_0(phone, (ipcarg_t) message,
-	    (ipcarg_t) device_id, (ipcarg_t) arg2, (ipcarg_t) service);
+	return (int) async_req_3_0(phone, (sysarg_t) message,
+	    (sysarg_t) device_id, (sysarg_t) arg2, (sysarg_t) service);
 }
 
@@ -103,5 +103,5 @@
 {
 	aid_t message_id;
-	ipcarg_t result;
+	sysarg_t result;
 	int string;
 
@@ -110,6 +110,6 @@
 
 	// request the address
-	message_id = async_send_1(phone, (ipcarg_t) message,
-	    (ipcarg_t) device_id, NULL);
+	message_id = async_send_1(phone, (sysarg_t) message,
+	    (sysarg_t) device_id, NULL);
 	string = measured_strings_return(phone, address, data, 1);
 	async_wait_for(message_id, &result);
@@ -143,11 +143,11 @@
 		return EBADMEM;
 	
-	ipcarg_t addr_len;
-	ipcarg_t prefix;
-	ipcarg_t content;
-	ipcarg_t suffix;
-	
-	ipcarg_t result = async_req_1_4(phone, (ipcarg_t) message,
-	    (ipcarg_t) device_id, &addr_len, &prefix, &content, &suffix);
+	sysarg_t addr_len;
+	sysarg_t prefix;
+	sysarg_t content;
+	sysarg_t suffix;
+	
+	sysarg_t result = async_req_1_4(phone, (sysarg_t) message,
+	    (sysarg_t) device_id, &addr_len, &prefix, &content, &suffix);
 	
 	packet_dimension->prefix = (size_t) prefix;
@@ -175,9 +175,9 @@
 {
 	if (error) {
-		async_msg_4(phone, (ipcarg_t) message, (ipcarg_t) device_id,
-		    (ipcarg_t) packet_id, (ipcarg_t) target, (ipcarg_t) error);
+		async_msg_4(phone, (sysarg_t) message, (sysarg_t) device_id,
+		    (sysarg_t) packet_id, (sysarg_t) target, (sysarg_t) error);
 	} else {
-		async_msg_3(phone, (ipcarg_t) message, (ipcarg_t) device_id,
-		    (ipcarg_t) packet_id, (ipcarg_t) target);
+		async_msg_3(phone, (sysarg_t) message, (sysarg_t) device_id,
+		    (sysarg_t) packet_id, (sysarg_t) target);
 	}
 	
@@ -201,9 +201,9 @@
 {
 	if (error) {
-		async_msg_4(phone, (ipcarg_t) message, (ipcarg_t) device_id,
-		    (ipcarg_t) packet_id, (ipcarg_t) sender, (ipcarg_t) error);
+		async_msg_4(phone, (sysarg_t) message, (sysarg_t) device_id,
+		    (sysarg_t) packet_id, (sysarg_t) sender, (sysarg_t) error);
 	} else {
-		async_msg_3(phone, (ipcarg_t) message, (ipcarg_t) device_id,
-		    (ipcarg_t) packet_id, (ipcarg_t) sender);
+		async_msg_3(phone, (sysarg_t) message, (sysarg_t) device_id,
+		    (sysarg_t) packet_id, (sysarg_t) sender);
 	}
 	
@@ -237,5 +237,5 @@
 {
 	aid_t message_id;
-	ipcarg_t result;
+	sysarg_t result;
 	int string;
 
@@ -246,6 +246,6 @@
 
 	// request the translation
-	message_id = async_send_3(phone, (ipcarg_t) message,
-	    (ipcarg_t) device_id, (ipcarg_t) count, (ipcarg_t) service, NULL);
+	message_id = async_send_3(phone, (sysarg_t) message,
+	    (sysarg_t) device_id, (sysarg_t) count, (sysarg_t) service, NULL);
 	measured_strings_send(phone, configuration, count);
 	string = measured_strings_return(phone, translation, data, count);
Index: uspace/lib/net/generic/packet_client.c
===================================================================
--- uspace/lib/net/generic/packet_client.c	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/net/generic/packet_client.c	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -57,5 +57,5 @@
  * @return		ENOMEM if there is not enough memory left.
  */
-int packet_copy_data(packet_t packet, const void *data, size_t length)
+int packet_copy_data(packet_t *packet, const void *data, size_t length)
 {
 	if (!packet_is_valid(packet))
@@ -81,8 +81,8 @@
  * @return		NULL if there is not enough memory left.
  */
-void *packet_prefix(packet_t packet, size_t length)
+void *packet_prefix(packet_t *packet, size_t length)
 {
 	if ((!packet_is_valid(packet)) ||
-	    (packet->data_start - sizeof(struct packet) -
+	    (packet->data_start - sizeof(packet_t) -
 	    2 * (packet->dest_addr - packet->src_addr) < length)) {
 		return NULL;
@@ -102,5 +102,5 @@
  * @return		NULL if there is not enough memory left.
  */
-void *packet_suffix(packet_t packet, size_t length)
+void *packet_suffix(packet_t *packet, size_t length)
 {
 	if ((!packet_is_valid(packet)) ||
@@ -124,5 +124,5 @@
  * @return		ENOMEM if there is not enough memory left.
  */
-int packet_trim(packet_t packet, size_t prefix, size_t suffix)
+int packet_trim(packet_t *packet, size_t prefix, size_t suffix)
 {
 	if (!packet_is_valid(packet))
@@ -143,5 +143,5 @@
  * @return		Zero if the packet is not valid.
  */
-packet_id_t packet_get_id(const packet_t packet)
+packet_id_t packet_get_id(const packet_t *packet)
 {
 	return packet_is_valid(packet) ? packet->packet_id : 0;
@@ -157,5 +157,5 @@
  * @return		EINVAL if the packet is not valid.
  */
-int packet_get_addr(const packet_t packet, uint8_t **src, uint8_t **dest)
+int packet_get_addr(const packet_t *packet, uint8_t **src, uint8_t **dest)
 {
 	if (!packet_is_valid(packet))
@@ -177,5 +177,5 @@
  * @return		Zero if the packet is not valid.
  */
-size_t packet_get_data_length(const packet_t packet)
+size_t packet_get_data_length(const packet_t *packet)
 {
 	if (!packet_is_valid(packet))
@@ -191,5 +191,5 @@
  * @return		NULL if the packet is not valid.
  */
-void *packet_get_data(const packet_t packet)
+void *packet_get_data(const packet_t *packet)
 {
 	if (!packet_is_valid(packet))
@@ -210,5 +210,5 @@
  */
 int
-packet_set_addr(packet_t packet, const uint8_t *src, const uint8_t *dest,
+packet_set_addr(packet_t *packet, const uint8_t *src, const uint8_t *dest,
     size_t addr_len)
 {
@@ -257,7 +257,7 @@
  * @return		NULL on error.
  */
-packet_t packet_get_copy(int phone, packet_t packet)
-{
-	packet_t copy;
+packet_t *packet_get_copy(int phone, packet_t *packet)
+{
+	packet_t *copy;
 	uint8_t * src = NULL;
 	uint8_t * dest = NULL;
Index: uspace/lib/net/generic/packet_remote.c
===================================================================
--- uspace/lib/net/generic/packet_remote.c	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/net/generic/packet_remote.c	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -64,5 +64,5 @@
  */
 static int
-packet_return(int phone, packet_t *packet, packet_id_t packet_id, size_t size)
+packet_return(int phone, packet_t **packet, packet_id_t packet_id, size_t size)
 {
 	ipc_call_t answer;
@@ -72,5 +72,5 @@
 	message = async_send_1(phone, NET_PACKET_GET, packet_id, &answer);
 
-	*packet = (packet_t) as_get_mappable_page(size);
+	*packet = (packet_t *) as_get_mappable_page(size);
 	rc = async_share_in_start_0_0(phone, *packet, size);
 	if (rc != EOK) {
@@ -86,5 +86,5 @@
 	}
 	
-	ipcarg_t result;
+	sysarg_t result;
 	async_wait_for(message, &result);
 	
@@ -107,5 +107,5 @@
  *			function.
  */
-int packet_translate_remote(int phone, packet_t *packet, packet_id_t packet_id)
+int packet_translate_remote(int phone, packet_t **packet, packet_id_t packet_id)
 {
 	int rc;
@@ -116,5 +116,5 @@
 	*packet = pm_find(packet_id);
 	if (!*packet) {
-		ipcarg_t size;
+		sysarg_t size;
 		
 		rc = async_req_1_1(phone, NET_PACKET_GET_SIZE, packet_id,
@@ -127,5 +127,5 @@
 	}
 	if ((*packet)->next) {
-		packet_t next;
+		packet_t *next;
 		
 		return packet_translate_remote(phone, &next, (*packet)->next);
@@ -148,9 +148,9 @@
  * @return		NULL on error.
  */
-packet_t packet_get_4_remote(int phone, size_t max_content, size_t addr_len,
+packet_t *packet_get_4_remote(int phone, size_t max_content, size_t addr_len,
     size_t max_prefix, size_t max_suffix)
 {
-	ipcarg_t packet_id;
-	ipcarg_t size;
+	sysarg_t packet_id;
+	sysarg_t size;
 	int rc;
 	
@@ -161,5 +161,5 @@
 	
 	
-	packet_t packet = pm_find(packet_id);
+	packet_t *packet = pm_find(packet_id);
 	if (!packet) {
 		rc = packet_return(phone, &packet, packet_id, size);
@@ -180,8 +180,8 @@
  * @return		NULL on error.
  */
-packet_t packet_get_1_remote(int phone, size_t content)
-{
-	ipcarg_t packet_id;
-	ipcarg_t size;
+packet_t *packet_get_1_remote(int phone, size_t content)
+{
+	sysarg_t packet_id;
+	sysarg_t size;
 	int rc;
 	
@@ -191,5 +191,5 @@
 		return NULL;
 	
-	packet_t packet = pm_find(packet_id);
+	packet_t *packet = pm_find(packet_id);
 	if (!packet) {
 		rc = packet_return(phone, &packet, packet_id, size);
Index: uspace/lib/net/il/arp_remote.c
===================================================================
--- uspace/lib/net/il/arp_remote.c	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/net/il/arp_remote.c	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -86,8 +86,8 @@
 {
 	aid_t message_id;
-	ipcarg_t result;
+	sysarg_t result;
 
 	message_id = async_send_2(arp_phone, NET_ARP_CLEAR_ADDRESS,
-	    (ipcarg_t) device_id, protocol, NULL);
+	    (sysarg_t) device_id, protocol, NULL);
 	measured_strings_send(arp_phone, address, 1);
 	async_wait_for(message_id, &result);
@@ -106,5 +106,5 @@
 {
 	return (int) async_req_1_0(arp_phone, NET_ARP_CLEAR_DEVICE,
-	    (ipcarg_t) device_id);
+	    (sysarg_t) device_id);
 }
 
@@ -136,8 +136,8 @@
 {
 	aid_t message_id;
-	ipcarg_t result;
+	sysarg_t result;
 
 	message_id = async_send_3(arp_phone, NET_ARP_DEVICE,
-	    (ipcarg_t) device_id, protocol, netif, NULL);
+	    (sysarg_t) device_id, protocol, netif, NULL);
 	measured_strings_send(arp_phone, address, 1);
 	async_wait_for(message_id, &result);
Index: uspace/lib/net/il/il_interface.c
===================================================================
--- uspace/lib/net/il/il_interface.c	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/net/il/il_interface.c	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -77,5 +77,5 @@
  *
  */
-int il_received_msg(int il_phone, device_id_t device_id, packet_t packet,
+int il_received_msg(int il_phone, device_id_t device_id, packet_t *packet,
     services_t target)
 {
Index: uspace/lib/net/il/ip_client.c
===================================================================
--- uspace/lib/net/il/ip_client.c	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/net/il/ip_client.c	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -51,5 +51,5 @@
  * @return		Zero if there is no IP header.
  */
-size_t ip_client_header_length(packet_t packet)
+size_t ip_client_header_length(packet_t *packet)
 {
 	ip_header_t *header;
@@ -152,5 +152,5 @@
  */
 int
-ip_client_prepare_packet(packet_t packet, ip_protocol_t protocol, ip_ttl_t ttl,
+ip_client_prepare_packet(packet_t *packet, ip_protocol_t protocol, ip_ttl_t ttl,
     ip_tos_t tos, int dont_fragment, size_t ipopt_length)
 {
@@ -208,5 +208,5 @@
  */
 int
-ip_client_process_packet(packet_t packet, ip_protocol_t *protocol,
+ip_client_process_packet(packet_t *packet, ip_protocol_t *protocol,
     ip_ttl_t *ttl, ip_tos_t *tos, int *dont_fragment, size_t *ipopt_length)
 {
Index: uspace/lib/net/il/ip_remote.c
===================================================================
--- uspace/lib/net/il/ip_remote.c	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/net/il/ip_remote.c	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -67,6 +67,6 @@
 {
 	return (int) async_req_4_0(ip_phone, NET_IP_ADD_ROUTE,
-	    (ipcarg_t) device_id, (ipcarg_t) gateway.s_addr,
-	    (ipcarg_t) address.s_addr, (ipcarg_t) netmask.s_addr);
+	    (sysarg_t) device_id, (sysarg_t) gateway.s_addr,
+	    (sysarg_t) address.s_addr, (sysarg_t) netmask.s_addr);
 }
 
@@ -86,5 +86,5 @@
     async_client_conn_t receiver)
 {
-	return (int) bind_service(service, (ipcarg_t) protocol, me, service,
+	return (int) bind_service(service, (sysarg_t) protocol, me, service,
 	    receiver);
 }
@@ -151,5 +151,5 @@
 	ipc_call_t answer;
 	aid_t message_id = async_send_1(ip_phone, NET_IP_GET_ROUTE,
-	    (ipcarg_t) protocol, &answer);
+	    (sysarg_t) protocol, &answer);
 	
 	if ((async_data_write_start(ip_phone, destination, addrlen) == EOK) &&
@@ -164,5 +164,5 @@
 	}
 	
-	ipcarg_t result;
+	sysarg_t result;
 	async_wait_for(message_id, &result);
 	
@@ -204,5 +204,5 @@
  */
 int ip_received_error_msg_remote(int ip_phone, device_id_t device_id,
-    packet_t packet, services_t target, services_t error)
+    packet_t *packet, services_t target, services_t error)
 {
 	return generic_received_msg_remote(ip_phone, NET_IP_RECEIVED_ERROR,
@@ -225,5 +225,5 @@
  *			function.
  */
-int ip_send_msg_remote(int ip_phone, device_id_t device_id, packet_t packet,
+int ip_send_msg_remote(int ip_phone, device_id_t device_id, packet_t *packet,
     services_t sender, services_t error)
 {
@@ -244,5 +244,5 @@
 {
 	return (int) async_req_2_0(ip_phone, NET_IP_SET_GATEWAY,
-	    (ipcarg_t) device_id, (ipcarg_t) gateway.s_addr);
+	    (sysarg_t) device_id, (sysarg_t) gateway.s_addr);
 }
 
Index: uspace/lib/net/include/icmp_client.h
===================================================================
--- uspace/lib/net/include/icmp_client.h	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/net/include/icmp_client.h	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -41,7 +41,7 @@
 #include <net/packet.h>
 
-extern int icmp_client_process_packet(packet_t, icmp_type_t *, icmp_code_t *,
+extern int icmp_client_process_packet(packet_t *, icmp_type_t *, icmp_code_t *,
     icmp_param_t *, icmp_param_t *);
-extern size_t icmp_client_header_length(packet_t);
+extern size_t icmp_client_header_length(packet_t *);
 
 #endif
Index: uspace/lib/net/include/icmp_interface.h
===================================================================
--- uspace/lib/net/include/icmp_interface.h	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/net/include/icmp_interface.h	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -51,8 +51,8 @@
 
 extern int icmp_destination_unreachable_msg(int, icmp_code_t, icmp_param_t,
-    packet_t);
-extern int icmp_source_quench_msg(int, packet_t);
-extern int icmp_time_exceeded_msg(int, icmp_code_t, packet_t);
-extern int icmp_parameter_problem_msg(int, icmp_code_t, icmp_param_t, packet_t);
+    packet_t *);
+extern int icmp_source_quench_msg(int, packet_t *);
+extern int icmp_time_exceeded_msg(int, icmp_code_t, packet_t *);
+extern int icmp_parameter_problem_msg(int, icmp_code_t, icmp_param_t, packet_t *);
 
 /*@}*/
Index: uspace/lib/net/include/il_interface.h
===================================================================
--- uspace/lib/net/include/il_interface.h	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/net/include/il_interface.h	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -51,5 +51,5 @@
 
 extern int il_device_state_msg(int, device_id_t, device_state_t, services_t);
-extern int il_received_msg(int, device_id_t, packet_t, services_t);
+extern int il_received_msg(int, device_id_t, packet_t *, services_t);
 extern int il_mtu_changed_msg(int, device_id_t, size_t, services_t);
 
Index: uspace/lib/net/include/ip_client.h
===================================================================
--- uspace/lib/net/include/ip_client.h	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/net/include/ip_client.h	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -45,9 +45,9 @@
 #include <ip_interface.h>
 
-extern int ip_client_prepare_packet(packet_t, ip_protocol_t, ip_ttl_t, ip_tos_t,
-    int, size_t);
-extern int ip_client_process_packet(packet_t, ip_protocol_t *, ip_ttl_t *,
+extern int ip_client_prepare_packet(packet_t *, ip_protocol_t, ip_ttl_t,
+    ip_tos_t, int, size_t);
+extern int ip_client_process_packet(packet_t *, ip_protocol_t *, ip_ttl_t *,
     ip_tos_t *, int *, size_t *);
-extern size_t ip_client_header_length(packet_t);
+extern size_t ip_client_header_length(packet_t *);
 extern int ip_client_set_pseudo_header_data_length(void *, size_t, size_t);
 extern int ip_client_get_pseudo_header(ip_protocol_t, struct sockaddr *,
Index: uspace/lib/net/include/ip_interface.h
===================================================================
--- uspace/lib/net/include/ip_interface.h	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/net/include/ip_interface.h	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -70,5 +70,5 @@
  * @return		EOK on success.
  */
-typedef int (*tl_received_msg_t)(device_id_t device_id, packet_t packet,
+typedef int (*tl_received_msg_t)(device_id_t device_id, packet_t *packet,
     services_t receiver, services_t error);
 
Index: uspace/lib/net/include/ip_remote.h
===================================================================
--- uspace/lib/net/include/ip_remote.h	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/net/include/ip_remote.h	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -45,10 +45,10 @@
 extern int ip_set_gateway_req_remote(int, device_id_t, in_addr_t);
 extern int ip_packet_size_req_remote(int, device_id_t, packet_dimension_t *);
-extern int ip_received_error_msg_remote(int, device_id_t, packet_t, services_t,
+extern int ip_received_error_msg_remote(int, device_id_t, packet_t *, services_t,
     services_t);
 extern int ip_device_req_remote(int, device_id_t, services_t);
 extern int ip_add_route_req_remote(int, device_id_t, in_addr_t, in_addr_t,
     in_addr_t);
-extern int ip_send_msg_remote(int, device_id_t, packet_t, services_t,
+extern int ip_send_msg_remote(int, device_id_t, packet_t *, services_t,
     services_t);
 extern int ip_get_route_req_remote(int, ip_protocol_t, const struct sockaddr *,
Index: uspace/lib/net/include/netif_local.h
===================================================================
--- uspace/lib/net/include/netif_local.h	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/net/include/netif_local.h	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -111,5 +111,5 @@
  *			message implementation.
  */
-extern int netif_send_message(device_id_t device_id, packet_t packet,
+extern int netif_send_message(device_id_t device_id, packet_t *packet,
     services_t sender);
 
@@ -198,5 +198,5 @@
     char **);
 extern int netif_probe_req_local(int, device_id_t, int, int);
-extern int netif_send_msg_local(int, device_id_t, packet_t, services_t);
+extern int netif_send_msg_local(int, device_id_t, packet_t *, services_t);
 extern int netif_start_req_local(int, device_id_t);
 extern int netif_stop_req_local(int, device_id_t);
@@ -208,5 +208,5 @@
 extern void null_device_stats(device_stats_t *);
 extern void netif_pq_release(packet_id_t);
-extern packet_t netif_packet_get_1(size_t);
+extern packet_t *netif_packet_get_1(size_t);
 extern int netif_init_module(async_client_conn_t);
 
Index: uspace/lib/net/include/netif_remote.h
===================================================================
--- uspace/lib/net/include/netif_remote.h	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/net/include/netif_remote.h	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -44,5 +44,5 @@
     char **);
 extern int netif_probe_req_remote(int, device_id_t, int, int);
-extern int netif_send_msg_remote(int, device_id_t, packet_t, services_t);
+extern int netif_send_msg_remote(int, device_id_t, packet_t *, services_t);
 extern int netif_start_req_remote(int, device_id_t);
 extern int netif_stop_req_remote(int, device_id_t);
Index: uspace/lib/net/include/nil_local.h
===================================================================
--- uspace/lib/net/include/nil_local.h	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/net/include/nil_local.h	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -77,5 +77,5 @@
  * 			received function.
  */
-extern int nil_received_msg_local(int, device_id_t, packet_t, services_t);
+extern int nil_received_msg_local(int, device_id_t, packet_t *, services_t);
 
 /** Message processing function.
Index: uspace/lib/net/include/nil_remote.h
===================================================================
--- uspace/lib/net/include/nil_remote.h	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/net/include/nil_remote.h	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -39,5 +39,5 @@
 
 extern int nil_device_state_msg_remote(int, device_id_t, int);
-extern int nil_received_msg_remote(int, device_id_t, packet_t, services_t);
+extern int nil_received_msg_remote(int, device_id_t, packet_t *, services_t);
 
 #endif
Index: uspace/lib/net/include/packet_client.h
===================================================================
--- uspace/lib/net/include/packet_client.h	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/net/include/packet_client.h	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -99,14 +99,14 @@
 	packet_trim((packet), sizeof(prefix), sizeof(suffix))
 
-extern void *packet_prefix(packet_t, size_t);
-extern void *packet_suffix(packet_t, size_t);
-extern int packet_trim(packet_t, size_t, size_t);
-extern int packet_copy_data(packet_t, const void *, size_t);
-extern packet_id_t packet_get_id(const packet_t);
-extern size_t packet_get_data_length(const packet_t);
-extern void *packet_get_data(const packet_t);
-extern int packet_get_addr(const packet_t, uint8_t **, uint8_t **);
-extern int packet_set_addr(packet_t, const uint8_t *, const uint8_t *, size_t);
-extern packet_t packet_get_copy(int phone, packet_t packet);
+extern void *packet_prefix(packet_t *, size_t);
+extern void *packet_suffix(packet_t *, size_t);
+extern int packet_trim(packet_t *, size_t, size_t);
+extern int packet_copy_data(packet_t *, const void *, size_t);
+extern packet_id_t packet_get_id(const packet_t *);
+extern size_t packet_get_data_length(const packet_t *);
+extern void *packet_get_data(const packet_t *);
+extern int packet_get_addr(const packet_t *, uint8_t **, uint8_t **);
+extern int packet_set_addr(packet_t *, const uint8_t *, const uint8_t *, size_t);
+extern packet_t *packet_get_copy(int, packet_t *);
 
 /*@}*/
Index: uspace/lib/net/include/packet_remote.h
===================================================================
--- uspace/lib/net/include/packet_remote.h	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/net/include/packet_remote.h	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -37,7 +37,7 @@
 #include <sys/types.h>
 
-extern int packet_translate_remote(int, packet_t *, packet_id_t);
-extern packet_t packet_get_4_remote(int, size_t, size_t, size_t, size_t);
-extern packet_t packet_get_1_remote(int, size_t);
+extern int packet_translate_remote(int, packet_t **, packet_id_t);
+extern packet_t *packet_get_4_remote(int, size_t, size_t, size_t, size_t);
+extern packet_t *packet_get_1_remote(int, size_t);
 extern void pq_release_remote(int, packet_id_t);
 
Index: uspace/lib/net/include/socket_core.h
===================================================================
--- uspace/lib/net/include/socket_core.h	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/net/include/socket_core.h	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -117,5 +117,5 @@
 extern int socket_destroy(int, int, socket_cores_t *, socket_ports_t *,
     void (*)(socket_core_t *));
-extern int socket_reply_packets(packet_t, size_t *);
+extern int socket_reply_packets(packet_t *, size_t *);
 extern socket_core_t *socket_port_find(socket_ports_t *, int, const char *,
     size_t);
Index: uspace/lib/net/include/tl_common.h
===================================================================
--- uspace/lib/net/include/tl_common.h	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/net/include/tl_common.h	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -57,6 +57,6 @@
     size_t);
 extern int tl_set_address_port(struct sockaddr *, int, uint16_t);
-extern int tl_prepare_icmp_packet(int, int, packet_t, services_t);
-extern int tl_socket_read_packet_data(int, packet_t *, size_t,
+extern int tl_prepare_icmp_packet(int, int, packet_t *, services_t);
+extern int tl_socket_read_packet_data(int, packet_t **, size_t,
     const packet_dimension_t *, const struct sockaddr *, socklen_t);
 
Index: uspace/lib/net/include/tl_interface.h
===================================================================
--- uspace/lib/net/include/tl_interface.h	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/net/include/tl_interface.h	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -52,5 +52,5 @@
 /*@{*/
 
-extern int tl_received_msg(int, device_id_t, packet_t, services_t, services_t);
+extern int tl_received_msg(int, device_id_t, packet_t *, services_t, services_t);
 
 /*@}*/
Index: uspace/lib/net/netif/netif_local.c
===================================================================
--- uspace/lib/net/netif/netif_local.c	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ uspace/lib/net/netif/netif_local.c	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -92,5 +92,5 @@
  */
 int netif_send_msg_local(int netif_phone, device_id_t device_id,
-    packet_t packet, services_t sender)
+    packet_t *packet, services_t sender)
 {
 	fibril_rwlock_write_lock(&netif_globals.lock);
@@ -307,5 +307,5 @@
  *
  */
-packet_t netif_packet_get_1(size_t content)
+packet_t *netif_packet_get_1(size_t content)
 {
 	return packet_get_1_remote(netif_globals.net_phone, content);
@@ -361,10 +361,10 @@
 	size_t length;
 	device_stats_t stats;
-	packet_t packet;
+	packet_t *packet;
 	measured_string_t address;
 	int rc;
 	
 	*answer_count = 0;
-	switch (IPC_GET_METHOD(*call)) {
+	switch (IPC_GET_IMETHOD(*call)) {
 	case IPC_M_PHONE_HUNGUP:
 		return EOK;
